"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnumValue = void 0;
const GQLElement_1 = require("../../../../classes/GQLElement");
class EnumValue extends GQLElement_1.GQLElement {
    constructor(name, value) {
        super(name);
        this.setValue(value);
    }
    get name() {
        return this._name;
    }
    get value() {
        return this._value;
    }
    /**
     * The teh value deprecation reason
     * @param deprecationReason The deprecation reason
     */
    setDeprecationReason(deprecationReason) {
        this._deprecationReason = deprecationReason;
    }
    /**
     * Set the value
     * @param value The value
     */
    setValue(value) {
        this._value = value;
    }
    /**
     * Create a new EnumValue
     * @param name The value name
     * @param value The value
     */
    static create(name, value) {
        return new EnumValue(name, value);
    }
    build() {
        this._built = {
            name: this.name,
            value: this.value,
            deprecationReason: this._deprecationReason,
            description: this._description,
            isDeprecated: !!this._deprecationReason,
            extensions: this.extensions,
        };
        return { ...this._built };
    }
}
exports.EnumValue = EnumValue;
//# sourceMappingURL=EnumValue.js.map